var docguide = new Object();

docguide.cachedData = null;
docguide.cachedVersion = null;

docguide.loadingInterval = null;
docguide.currentLoadingImage = 1;

docguide.viewBreadcrumb = new Array();

docguide.listScroll = null;
docguide.browseScroll = null;
docguide.viewScroll = null;

docguide.networkAlert = false;

docguide.scrollOptions = {
	vScroll: true,
	hScroll: false,
	vScrollbar: false,
	hScrollbar: false,
	bounce: true
};

docguide.initialize = function(){
	//check if localStorage is supported.
	if(window.localStorage){
		docguide.cachedData = window.localStorage.getItem("content");
		docguide.cachedVersion = window.localStorage.getItem("version");
	}
	
	if(docguide.cachedData != null){
		docguide.cachedData = JSON.parse(docguide.cachedData);
	}
	
	docguide.fetchData();
	
	//create a timeout for the loading page.
	setTimeout(function(){
		//change to the list page after some advertisment.
		mobile.changePage("list");
		
		if(docguide.networkAlert){
			alert("We detected an issue with your network connection, some data may be out of date or missing.");
		}
		
		docguide.drawData();
		
		//stop the loading image from spinning until the end of time.
		clearInterval(docguide.loadingInterval);
	}, 6000);
}
docguide.fetchData = function(){
	jQuery.ajax('http://precyseuniversity.com/moodle/custom/docguide/data.php', {
		data: {
			"client-version": docguide.cachedVersion
		},
		dataType: 'json',
		timeout: 5000,
		success: function(data){
			if(data.status == 'success'){
				if(data.version != docguide.cachedVersion){
					docguide.cachedData = data.content;
					docguide.cachedVersion = data.version;
					window.localStorage.setItem("content", JSON.stringify(data.content));
					window.localStorage.setItem("version", data.version);
				}
			}else{
				docguide.networkAlert = true;
			}
			//docguide.drawData();
		},
		error: function(){
			docguide.networkAlert = true;
			//docguide.drawData();
		}
	});
}
docguide.drawData = function(){
	$("#list-content").empty();
	$(docguide.cachedData).each(function(key, value){
		$("#list-content").append('<div data-id="'+key+'" class="list-item" style="font-size: '+mobile.heightProp(28)+'px; padding-left: '+mobile.widthProp(20)+'px; padding-right: '+mobile.widthProp(20)+'px; padding-top: '+mobile.heightProp(8)+'px; padding-bottom: '+mobile.heightProp(8)+'px;"><div class="text-trim" style="font-weight: bold; font-size: '+mobile.heightProp(32)+'px;"><b>'+value.title+'</b></div><div class="text-trim">'+value.content.replace(/<(?:.|\n)*?>/gm, '')+'</div></div>');
	});
	$("#list-content").children().click(function(){
		docguide.loadPage($(this).attr('data-id'));
	});
	$(docguide.cachedData).each(function(key, value){
		$("#browse-content").append('<div data-id="'+key+'" class="list-item" style="font-size: '+mobile.heightProp(28)+'px; padding-left: '+mobile.widthProp(20)+'px; padding-right: '+mobile.widthProp(20)+'px; padding-top: '+mobile.heightProp(8)+'px; padding-bottom: '+mobile.heightProp(8)+'px;"><div class="text-trim" style="font-weight: bold; font-size: '+mobile.heightProp(32)+'px;"><b>'+value.title+'</b></div><div class="text-trim">'+value.content.replace(/<(?:.|\n)*?>/gm, '')+'</div></div>');
	});
	$("#browse-content").children().click(function(){
		docguide.loadPage($(this).attr('data-id'));
	});
}
docguide.findPage = function(title){
	for(key in this.cachedData){
		var value = this.cachedData[key];
		if(value.title.toLowerCase() == title.toLowerCase()){
			return key;
		}
	}
	return false;
}
docguide.loadPage = function(pageid){
	if(docguide.viewBreadcrumb.length < 1){
		$("#view-back").attr('src', 'images/button-search.png');
		$("#view-back").css('height', mobile.heightProp(56));
		$("#view-back").css('width', mobile.widthProp(155));
	}else{
		$("#view-back").attr('src', 'images/button-back.png');
		$("#view-back").css('height', mobile.heightProp(56));
		$("#view-back").css('width', mobile.widthProp(125));
	}
	$("#view-content").empty();
	$("#view-content").append('<div id="view-title" style="color: #21759B; font-weight: bold;">'+this.cachedData[pageid].title+'</div>');
	$("#view-content").append(this.cachedData[pageid].content);
	$("#view-content").find('li').css('background-position', mobile.widthProp(12)+'px '+(mobile.heightProp(25)-mobile.heightProp(7))+'px');
	$("#view-content").find('li').css('background-size', mobile.heightProp(14)+'px '+mobile.heightProp(14)+'px');
	$("#view-content").find('li').css('padding-left', (mobile.widthProp(24) + mobile.heightProp(14))+'px');
	$("#view-content").find('a').click(function(){
		var nextpage = docguide.findPage($(this).attr('title'));
		if(nextpage === false){
			alert('Page not found...');
			return false;
		}
		docguide.loadPage(nextpage);
		return false;
	});
	docguide.viewBreadcrumb.push(pageid);
	mobile.changePage("view");
	docguide.viewScroll.refresh();
}
docguide.backPage = function(){
	docguide.viewBreadcrumb.pop();
	if(docguide.viewBreadcrumb.length < 1){
		mobile.changePage("list");
		return;
	}
	var pageid = docguide.viewBreadcrumb.pop();
	if(pageid == "browse"){
		docguide.viewBreadcrumb.push("browse");
		mobile.changePage("browse");
	}else{
		docguide.loadPage(pageid);
	}
}